
/* 用法
 $ajax({
     method: "请求的方式",
     url: "请求地址",
     data: {
         a: "参数1",
         b: "参数2"
     },
     aysn: true,
     contentType: "application/x-www-form-urlencoded",
     success: function (row) {
         var obj=JSON.parse(row)
         console.log(obj,"请求成功的数据");
     }
 })
  */
// 以对象的形式接收传进来的参数，那么形参必须要于对象的属性一样
function $ajax({ method, url, data, aysn, contentType, success }) {
    // console.log
    // (method);
    // console.log(url);
    // console.log(data);
    // console.log(aysn);
    // console.log(contentType);
    // console.log(success);
    // console.log(error);
    // 1 创建Ajax对象
    var xhr = new XMLHttpRequest()
    // {
    //     a:"参数1",
    //     b:"参数2"
    // }
    // 将对象转成a=参数1&b=参数2
    // 讲对象处理成拼接字符串
    data = querystring(data)

    // 如果是get并且data有数据，那么拼接?和参数：http://www.baidu.com?a=参数1&b=参数2
    // 如果是get不需要传参：http://www.baidu.com
    // 否则就是post：http://www.baidu/com
    if (method == "get" && data.length) {
        url += "?" + data
    }
    // url  在get中url拼接参数 1、接口地址?参数1=参数值1&参数n=参数值n  2、接口地址
    // url  在post中url 直接就是接口地址
    // 2 创建http请求 , get请求拼接参数是在open中，
    xhr.open(method, url, aysn)

    // 设置请求头
    // 如果有请求头，
    if (contentType) {
        // 就设置请求头
        xhr.setRequestHeader("Content-type", contentType)
    }

    // 3 发送请求 post拼接参数      在发送请求之前设置请求头
    // 如果是get就直接发送
    if (method == "get") {
        xhr.send()
    } else {
        // 否则拼接参数
        xhr.send(data)
    }

    

    // 4 设置监听函数
    xhr.onreadystatechange = function () {
        if (xhr.readyState === 4 && xhr.status === 200) {
            // 返回的数据
            // 调用传进来的对象中的函数，回调函数
            success(xhr.responseText)
            // } else {
            //     // 请求失败
            //     error(xhr.responseText)
            // }
        }
    }
}
function querystring(obj) {
    // console.log(obj)
    var str = ""
    // 遍历obj
    for (var i in obj) {
        // console.log(i); //属性
        // console.log(obj[i]); //属性值
        // 属性=属性值&属性=属性值
        str += i + "=" + obj[i] + "&"
    }
    // tel=123456&pa=789
    // 截取删除最后一项
    return str.substring(0, str.length - 1)
}
